function setping (ping, ip) {	
		$('#'+ip.replace(/\.+/g,"")).html(ping);
}


$(function() {

	var servers = new Array();
	var playerlist = new Array();
	
	function pingServer(ip) {
		getping(ip);
	}

	function saveServers() {		
		gReadingJson = true;	
		var path = getDataPath();
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		var output = fso.OpenTextFile(path,2,true);
		output.WriteLine(JSON.stringify(servers));		
		output.Close();
		gReadingJson = false;		
	}

	function readServers() {
		gReadingJson = true;	
		var path = getDataPath();
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		var input = fso.OpenTextFile(path,1);
		var inputservers = "";
		if(input != null) {
			while (!input.AtEndOfStream) {
				inputservers = inputservers + input.ReadLine();
			}
			gReadingJson = false
			try {
				servers = JSON.parse(inputservers);	
			} catch (e) {				
				alert ("fail");
			}
		}				
		input.Close();
		return servers;
	}
	
	$('#addservers input').change(function() {
		System.Gadget.Settings.writeString($(this).attr('id'),$(this).val());
	});		
	var serverip = System.Gadget.Settings.readString("serverip");
	var serverport = System.Gadget.Settings.readString("serverport");
	var serverqp = System.Gadget.Settings.readString("serverqp");
	
	$('#serverip').val(serverip);
	$('#serverport').val(serverport);
	$('#serverqp').val(serverqp);
	
	$("#tabs").tabs();
	$(".ui-tabs-nav").css({"font-size":"12px"});
	$(".ui-tabs-nav li a").css({"padding":"0.2em 0.5em"});
	$('#servers,#details,#addservers').css({"padding":"0","font-size":"0.9em"});
	
	var oTable;
	oTable = $('#servertable').dataTable({
		"bJQueryUI": true,
		"sPaginationType": "full_numbers",
		"iDisplayLength": 10,
		"bLengthChange": false,
		"bAutoWidth": false,
		"aoColumns": [ 
			null,
			null,
			null,
			null,
			null,
			null,
			{ "bSortable": false }
		]
	});
		
	var team1Table;
	team1Table = $('#dteam1').dataTable({
		"bJQueryUI": true,
		"sPaginationType": "full_numbers",
		"iDisplayLength": 10,
		"bInfo": false,
		"bFilter": false,
		"bLengthChange": false,
		"bAutoWidth": false
	});
	
	var team2Table;
	team2Table = $('#dteam2').dataTable({
		"bJQueryUI": true,
		"sPaginationType": "full_numbers",
		"iDisplayLength": 10,
		"bInfo": false,
		"bFilter": false,
		"bLengthChange": false,
		"bAutoWidth": false		
	});
	
	
	$('#servertable_first').html('<img src="images/resultset first .png" />');
	$('#servertable_previous').html('<img src="images/resultset previous .png" />');
	$('#servertable_next').html('<img src="images/resultset next .png" />');
	$('#servertable_last').html('<img src="images/resultset last .png" />');
	$('.ui-icon').css({"float":"left"});	
	$('#servertable_filter').append(" | <span id='refreshservers'><img src='images/arrow-circle-double-135.png' style='vertical-align: bottom; border: 0' /> Refresh servers</span>");
	$('#refreshservers').click(function() {
		update();
	});
	$('#refreshservers').fadeOut().fadeIn().fadeOut().fadeIn().fadeOut().fadeIn();
	$("#progressbar").progressbar({
		value: 0
	});
	$('#progressbar').css({"height":"15px","font-size":"0.9em"});
	$('#progressbar').after("<div id='progressnumbers'></div>");

	$('#addserver').button();
	$('#addserver').click(function(){
		var ip = $('#serverip').val();
		var port =  $('#serverport').val();
		var queryport =  $('#serverqp').val();
		addserver(ip, port, queryport);
		$('#serverip,#serverport,#serverqp').val("");
		$('#serverip,#serverport,#serverqp').each(function() {
			System.Gadget.Settings.writeString($(this).attr('id')," ");
		});
		$('#tabservers').trigger('click');
	});
	
	
	initialReadServers();
	
	function setDefaultServers () {
		servers = { "list": [
		  {"ip":"94.75.249.96","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"62.104.179.12","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"91.198.152.238","port":"19569","queryport":"41855","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"188.72.255.136","port":"19569","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"87.98.246.100","port":"19567","queryport":"48890","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"81.19.214.242","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"91.198.152.236","port":"19570","queryport":"46709","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"87.98.245.55","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"62.104.17.82","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"81.19.213.60","port":"19567","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"213.163.78.151","port":"19574","queryport":"48800","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"91.198.152.20","port":"19571","queryport":"48804","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"78.159.102.101","port":"10030","queryport":"48888","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"91.198.152.129","port":"19567","queryport":"48800","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "},
		  {"ip":"91.198.152.244","port":"19571","queryport":"46714","servername":" ","gamemode":" ","map":" ","players":" ","ping":" "}  
		] };	
	}
	
function initialReadServers() {	
	servers = readServers();	
	
	if(servers.list == "") {
		setDefaultServers ();
	}	
	
	oTable.fnClearTable(0);	
	
	$(servers.list).each(function(i) {
		addRow(this.servername, this.ip, this.port, this.gamemode, this.map, this.players, "-", i);
	});	
}

function addRow (servername, ip, port, gamemode, map, players, ping, index) {
	if(port != "") {
		ipport = ip+":"+port;
	} else {
		ipport = ip;
	}
	//var options = "<img id='details-"+index+"' class='optionicon' title='Serverdetails' src='images/zoom .png' /> <img id='delete-"+index+"' class='optionicon' title='Remove Server from list' src='images/delete .png' /> ";
	var options = "<img id='delete-"+index+"' class='optionicon' title='Remove Server from list' src='images/delete .png' />";
	var mappic = "<img src='images/maps/"+map+".jpg' style='width: 240; height: 135' />";
	
	if(map != "n/a" && map != "ZZZ (n/a)") {
		var maphtml = '<span id="mapview'+index+'" title="'+mappic+'" >' + map + '</span>';
	} else {
		maphtml = map;
	}
		oTable.fnAddData( [				
		servername,			
		ipport,	
		gamemode,			
		maphtml,				
		players,
		ping,
		options ] );
		
	if(map != "n/a" && map != "ZZZ (n/a)") {
		$("#mapview"+index).tipTip();
	}
	$("#delete-"+index).click(function() {
		var id = $(this).attr('id');
		var splits = id.split("-");
		var index = parseInt(splits[1]);
		oTable.fnDeleteRow(index);
		servers.list.remove(index);
		saveServers();
	});
	/*
	$("#details-"+index).click(function() {			
		var id = $(this).attr('id');
		var splits = id.split("-");
		var index = parseInt(splits[1]);
		$('#details').trigger('click');
		$('#dservername').html(servers.list[index].servername);
		$('#dip').html(servers.list[index].ip);
		$('#dport').html(servers.list[index].port);
		$('#dqueryport').html(servers.list[index].queryport);
		$('#dplayers').html(servers.list[index].players);
		$('#dping').html(servers.list[index].ping);
		team1Table.fnClearTable( 0 );
		team2Table.fnClearTable( 0 );
		
		$(playerlist[index][0]).each(function(i) {
			team1Table.fnAddData( [
				playerlist[index][0][i][0],
				playerlist[index][0][i][1],
				playerlist[index][0][i][2],
				playerlist[index][0][i][3],
				playerlist[index][0][i][4] ]
			);
		});		
		
		$(playerlist[index][1]).each(function(i) {
			team2Table.fnAddData( [
				playerlist[index][0][i][0],
				playerlist[index][0][i][1],
				playerlist[index][0][i][2],
				playerlist[index][0][i][3],
				playerlist[index][0][i][4] ]
			);
		});
	});
	*/
	
}
	
function addserver (ip,port,queryport) {
	servers.list.push({"ip":ip,"port":port,"queryport":queryport,"servername":"","gamemode":"","map":"","players":"","ping":""});
	var lastindex = servers.list.length-1;
	queryserver(servers.list[lastindex].ip,servers.list[lastindex].port,servers.list[lastindex].queryport,lastindex);
}

function runserver (ip,port) {
	//System.Shell.execute(game.replace(/\//g, "\\"));
}

function update () {
	playerlist = new Array(servers.list.length);
	oTable.fnClearTable(0);
	$("#progressbar").progressbar( "option", "value", 0 );	
	$('#progressnumbers').html("<span id='serverperc'>0%</span> (<span id='progress'>0</span>/<span id='servercount'>"+servers.list.length+"</span>)")
	$(servers.list).each(function(index) {
		queryserver(this.ip,this.port,this.queryport,index);
	});		
}

function queryserver(ip,port,queryport,index) {		

			var ipport = ip + ":" + port;
			var url = "http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20html%20where%20url%3D%22http%3A%2F%2Fbattletracker.com%2Fwebspec%2Fbc2%2Findex.php%2F%3Faddr%3D"+ipport+":"+queryport+"%22%20and%20xpath%3D'%2F%2Ftable'";
			playerlist[index] = new Array(2);		
			$.ajax({
			  url: url,
			  success: function(xml) {
				var servername = "unknown";
				var mapid = "";
				var gamemode = "n/a";
				var players = "n/a";
				var teams = new Array();
				var ping = "-";
				playerlist[index][0] = new Array(30);
				playerlist[index][1] = new Array(30);
				$(xml).find('table').each(function(i){
					if(i == 1) {
						$(this).find('td').each(function(k){
							if(k == 1) {						
								servername = $(this).text().replace(/\s+/g," ");
								if(servername.length < 2) { servername = "unknown"; }
							} else if (k == 5) {
								mapid = $(this).text().replace(/\s+/g,"");
							} else if (k == 7) {
								gamemode = $(this).text().replace(/\s+/g,"");							
							} else if (k == 9) {
								players = $(this).text().replace(/\s+/g," ");
							}
						});
					} else if (i == 3) {
						$(this).find('tr').each(function(m){		
							playerlist[index][0][m] = new Array(5);
							if(m > 3) {
								$(this).find('td').each(function(n){										
									playerlist[index][0][m][n] = $(this).text();	
									if(index == 2) {
									}
								});
							}
						});
					} else if (i == 4) {
						$(this).find('tr').each(function(m){
							playerlist[index][1][m] = new Array(5);						
							if(m > 3) {
								$(this).find('td').each(function(n){										
									playerlist[index][1][m][n] = $(this).text();								
								});
							}
						});
					}
				});
					
				if(typeof maps[mapid] != "undefined") {
					var map = maps[mapid].map;
					var mode = maps[mapid].mode;
				} else {
					var map = "n/a";
					var mode = "n/a";
				}
				
				servername = servername.replace(/\s+/g," ").substring(0, 50)
				var serverlink = "<a href='http://battletracker.com/bc2server/"+ipport+":"+queryport+"/'>"+servername+"</a>";
				var ipportlink = "<a href='http://battletracker.com/bc2server/"+ipport+":"+queryport+"/'>"+ipport+"</a>";
				
			if(servername != "unknown") {						
					var ping = "<span id='"+ip.replace(/\.+/g,"")+"'>-</span>";					
					addRow(serverlink, ipportlink, "", gamemode, map, players, ping, index);					

					/* Call VBS Script to ping this server, if it does not 
						response, it doesn't meen it is offline. Ping protocoll is 
						used here and does not cover bad company 2 server query ping */ 
					pingServer(ip);					

				} else {					
					addRow("ZZZ unkown", ipportlink, "", "ZZZ (n/a)", "ZZZ (n/a)", "0", "-", index);
				}

				updateServer(index, ip, port, queryport, servername, gamemode, map, players, ping);
			
				var progress = $('#progress').html();
				var percentage = Math.round(((parseInt(progress)+1)/servers.list.length)*100);
				if(percentage >= 100) {
					percentage = 100;
					saveServers();
				}
				$("#progressbar").progressbar( "option", "value", percentage );
				$('#progress').html(parseInt(progress)+1);
				$('#serverperc').html(percentage+"%");
				
				} // success
			});	
}      
		   

function updateServer(index, ip, port, queryport, servername, gamemode, map, players, ping) {
	servers.list[index].ip = ip;
	servers.list[index].port = port;
	servers.list[index].queryport = queryport;
	servers.list[index].servername = servername;
	servers.list[index].gamemode = gamemode;
	servers.list[index].map = map;
	servers.list[index].players = players;
	servers.list[index].ping = ping;
	saveServers();
}				

function getDataPath() {
	var path = System.Gadget.Settings.readString("userpath");
	
	if(path == "") {
        var item = System.Shell.itemFromPath(System.Gadget.path + "\\");
		var folderPath = item.path;
        
        if(item == null) {
            System.Shell.Folder.newFolder(folderPath);
            item = System.Shell.itemFromPath(folderPath);
        }
		
        path = folderPath + "\\servers.txt";
	    System.Gadget.Settings.writeString("userpath", path);
	}	
	return path;
}

/** Datapath debugging 
	@return path
**/
function getDataPathD() {
		var folderPath = "C:\\Users\\gabel\\AppData\\Local\\Microsoft\\Windows Sidebar\\Gadgets\\bc2stats2.4.6.gadget"	
        path = folderPath + "\\servers.txt";
	return path;
}

/** Array Remove - By John Resig (MIT Licensed)
	@return array
**/
Array.prototype.remove = function(from, to) {
  var rest = this.slice((to || from) + 1 || this.length);
  this.length = from < 0 ? this.length + from : from;
  return this.push.apply(this, rest);
};
  
});

var maps = {MP_001: {mode:'Conquest', map:'Panama Canal'},
		   MP_003: {mode:'Conquest', map:'Laguna Alta'},
		   MP_005: {mode:'Conquest', map:'Atacama Desert'},
		   MP_006CQ: {mode:'Conquest', map:'Arica Harbor'},
		   MP_007: {mode:'Conquest', map:'White Pass'},
		   MP_009CQ: {mode:'Conquest', map:'Laguna Presa'},
		   MP_002: {mode:'Rush', map:'Valparaso'},
		   MP_004: {mode:'Rush', map:'Isla Inocentes'},
		   MP_006: {mode:'Rush', map:'Arica Harbor'},
		   MP_008: {mode:'Rush', map:'Nelson Bay'},
		   MP_009GR: {mode:'Rush', map:'Laguna Presa'},
		   MP_012GR: {mode:'Rush', map:'Port Valdez'},
		   MP_001SR: {mode:'Squadrush', map:'Panama Canal'},
		   MP_002SR: {mode:'Squadrush', map:'Valparaso'},
		   MP_005SR: {mode:'Squadrush', map:'Atacama Desert'},
		   MP_012SR: {mode:'Squadrush', map:'Port Valdez'},
		   MP_004SDM: {mode:'Squad Deathmatch', map:'Isla Inocentes'},
		   MP_006SDM: {mode:'Squad Deathmatch', map:'Arica Harbor'},
		   MP_007SDM: {mode:'Squad Deathmatch', map:'White Pass'},
		   MP_009SDM: {mode:'Squad Deathmatch', map:'Laguna Presa'}};	